--- u-boot-2011.06_original/drivers/i2c/cnc1900_i2c.c	1970-01-01 08:00:00.000000000 +0800
+++ u-boot-2011.06/drivers/i2c/cnc1900_i2c.c	2014-07-29 17:28:38.819972000 +0800
@@ -0,0 +1,455 @@
+#include <common.h>
+#include <asm/io.h>
+#include "cnc1900_i2c.h"
+
+#if defined(CONFIG_HARD_I2C)
+
+#define i2c_writeb(v,a)    writeb(v, (CONFIG_SYS_I2C_BASE + (a)))
+#define i2c_writew(v,a)    writew(v, (CONFIG_SYS_I2C_BASE + (a)))
+#define i2c_writel(v,a)    writel(v, (CONFIG_SYS_I2C_BASE + (a)))
+
+#define i2c_readb(a)       readb((CONFIG_SYS_I2C_BASE + (a)))
+#define i2c_readw(a)       readw((CONFIG_SYS_I2C_BASE + (a)))
+#define i2c_readl(a)       readl((CONFIG_SYS_I2C_BASE + (a)))
+
+#define I2C_CLK_MHZ  (45000000/1000000)
+
+#define I2C_DEBUG_LEVEL0	(0)	/* Quiet   */
+#define I2C_DEBUG_LEVEL1	(1)	/* Audible */
+#define I2C_DEBUG_LEVEL2	(2)	/* Loud    */
+#define I2C_DEBUG_LEVEL3	(3)	/* Noisy   */
+
+//#define CONFIG_CNC1800L_I2C_DEBUG
+//#define CONFIG_I2C_DEBUG_VERBOSE 3
+
+#ifdef CONFIG_CNC1900_I2C_DEBUG
+#define DEBUG_CNC1900I2C(n, args...)				\
+ 	do {						\
+		if (n <= CONFIG_I2C_DEBUG_VERBOSE)	\
+			printf(args);			\
+	} while(0)
+#else /* CONFIG_I2C_DEBUG */
+#define DEBUG_CNC1900I2C(n, args...) do { } while(0)
+#endif
+
+static unsigned int previous_speed_cnt;
+
+
+static unsigned int ss_ic_sclh_cnt;
+static unsigned int ss_ic_scl_cnt;
+static unsigned int fs_ic_sclh_cnt;
+static unsigned int fs_ic_scl_cnt;
+static unsigned int default_speed_cnt;
+
+static uchar previous_chip = 0x7f;
+int i2c_probe (uchar chip)
+{
+    int i = 0;
+    int time_cnt;
+    int fifocount=0;
+    fifocount=fifocount;
+    i2c_writew(0x0,IC_RESET);
+    i=i2c_readw(IC_RAW_INTR_STAT);
+    fifocount = i2c_readw(IC_TXFLR);
+    i2c_writew(0x1, IC_ENABLE);
+    i2c_writew(((chip<<1)&0xff)|0x100,IC_DATA_CMD);
+    i2c_writew(0x00,IC_DATA_CMD);
+    i2c_writew(0x00,IC_DATA_CMD);
+    i2c_writew(0x00,IC_DATA_CMD);
+    i2c_writew(0x00,IC_DATA_CMD);
+    i2c_writew(0x01,IC_TX_TL);
+//     if (i2c_readw(IC_STAT) & 0x8) {
+//         i = i2c_readw(IC_DATA_CMD);
+//     }
+    time_cnt =0;
+    do {
+        time_cnt ++;
+        i=i2c_readw(IC_RAW_INTR_STAT);
+    } while (i==0 && time_cnt < 1000000);
+    if (time_cnt>=1000000) {              //Bus Err
+        i2c_writew(0x03,IC_FIFO_CLR);	  //clear tx/rx fifo
+        i2c_writew(0x1,IC_RESET);
+        i2c_writew(0x0,IC_RESET);
+        i2c_writew(0x1,IC_ENABLE);
+        i2c_writew(0x700,IC_DATA_CMD);    //write stop bit
+        DEBUG_CNC1900I2C(I2C_DEBUG_LEVEL0,"Error:Timeout!\n");
+        return 1;
+    }
+    if (i&0x20) {								//No ACK
+        i2c_writew(0x20,IC_INTR_CLR);
+        i2c_writew(0x03,IC_FIFO_CLR);			//clear tx/rx fifo
+        i2c_writew(0x700,IC_DATA_CMD);
+        DEBUG_CNC1900I2C(I2C_DEBUG_LEVEL0,"Error:No Slave sends ack!\n");
+        return 1;
+    }
+    i2c_writew(0x20,IC_INTR_CLR);
+    i2c_writew(0x03,IC_FIFO_CLR);			//clear tx/rx fifo
+    i2c_writew(0x700,IC_DATA_CMD);
+    return 0;
+}
+
+
+int i2c_read(uchar chip,uint addr, int alen, uchar * buffer, int len)
+{
+    int i;
+    int cmd_cnt;
+    int data_cnt;
+    unsigned int time_cnt;
+    unsigned char *byte_addr = (unsigned char *) &addr;
+    unsigned char *p = buffer;
+    //    printf("alen =%d\n",alen);
+    time_cnt=0;
+    while (i2c_readw(IC_STAT)&0x20) {
+        if (time_cnt>=100000) {       //Bus Err
+            i2c_writew(0x1,IC_RESET);
+            i2c_writew(0x0,IC_RESET);
+            i2c_writew(0x1,IC_ENABLE);
+            i2c_writew(0x700,IC_DATA_CMD);     //write stop bit
+            previous_chip = 0;
+            DEBUG_CNC1900I2C(I2C_DEBUG_LEVEL0,"Error:Timeout!\n");
+            return 1;
+        }
+        time_cnt++;
+    }
+    i2c_writew(0x1, IC_ENABLE);
+    if (alen > 0) {
+        i2c_writew(((chip<<1)&0xff)|0x100,IC_DATA_CMD);
+    }
+    for (i = alen - 1; i >= 0; i--) {
+        i2c_writew(0x200|(byte_addr[i]& 0xff),IC_DATA_CMD);
+        DEBUG_CNC1900I2C(I2C_DEBUG_LEVEL3,"Chipaddress=0x%x, subaddr=0x%x, written_addr=0x%x\n",
+              chip, addr, byte_addr[i]);
+    }
+    i2c_writew(0x101|((chip<<1)&0xff),IC_DATA_CMD);
+    data_cnt = 0;
+    cmd_cnt = 0;
+    time_cnt=0;
+    while (data_cnt < len) {
+        if (time_cnt>=100000) {       //Bus Err
+            i2c_writew(0x1,IC_RESET);
+            i2c_writew(0x0,IC_RESET);
+            i2c_writew(0x1,IC_ENABLE);
+            i2c_writew(0x700,IC_DATA_CMD);     //write stop bit
+            previous_chip = 0;
+            DEBUG_CNC1900I2C(I2C_DEBUG_LEVEL0,"Error:Timeout!\n");
+            return 1;
+        }
+        time_cnt++;
+        while ((cmd_cnt < len) && (i2c_readw(IC_STAT) & 0x2)) {
+            if (cmd_cnt+1==len) {
+                i2c_writew(0x600,IC_DATA_CMD);		//write stop bit
+            } else {
+                i2c_writew(0x400, IC_DATA_CMD);
+            }
+            cmd_cnt++;
+        }
+        if (i2c_readw(IC_STAT) & 0x8) {
+            *p = i2c_readw(IC_DATA_CMD);
+            DEBUG_CNC1900I2C(I2C_DEBUG_LEVEL3,"Chipaddress=0x%x, subaddr=0x%x, readed=0x%x\n",
+                  chip, addr, *p);
+            p++;
+            data_cnt++;
+        }
+        if ((i=i2c_readw(IC_RAW_INTR_STAT)) & 0xe0) {
+            DEBUG_CNC1900I2C(I2C_DEBUG_LEVEL0,"Chipaddress=0x%x, subaddr=0x%x, IC_RAW_INTR_STAT=0x%x\n",
+                  chip, addr, i);
+            i2c_writew(0x03,IC_FIFO_CLR);			//clear tx/rx fifo
+            if (i&0x40) {							//Arbitration Lost
+                i2c_writew(0x40,IC_INTR_CLR);
+                DEBUG_CNC1900I2C(I2C_DEBUG_LEVEL0,"Error:Arbitration lost!\n");
+            }
+            if (i&0x80) {
+                i2c_writew(0x80,IC_INTR_CLR);
+                DEBUG_CNC1900I2C(I2C_DEBUG_LEVEL0,"Error:Timeout!\n");
+            }
+            if (i&0x20) {							//No ACK
+                i2c_writew(0x20,IC_INTR_CLR);
+                i2c_writew(0x700,IC_DATA_CMD);
+                DEBUG_CNC1900I2C(I2C_DEBUG_LEVEL0,"Error:No Slave sends ack!\n");
+            }
+            previous_chip = 0;
+            return -1;
+        }
+    }
+    time_cnt=0;
+    while (!(i2c_readw(IC_STAT)&0x04)) {
+        if (time_cnt>=100000) {       //Bus Err
+            i2c_writew(0x1,IC_RESET);
+            i2c_writew(0x0,IC_RESET);
+            i2c_writew(0x1,IC_ENABLE);
+            i2c_writew(0x700,IC_DATA_CMD);     //write stop bit
+            previous_chip = 0;
+            DEBUG_CNC1900I2C(I2C_DEBUG_LEVEL0,"Error:Timeout!\n");
+            return 1;
+        }
+        time_cnt++;
+        if ((i=i2c_readw(IC_RAW_INTR_STAT)) & 0xe0) {
+            DEBUG_CNC1900I2C(I2C_DEBUG_LEVEL0,"Chipaddress=0x%x, subaddr=0x%x, IC_RAW_INTR_STAT=0x%x\n",
+                  chip, addr, i);
+            i2c_writew(0x03,IC_FIFO_CLR);			//clear tx/rx fifo
+            if (i&0x40) {							//Arbitration Lost
+                i2c_writew(0x40,IC_INTR_CLR);
+                DEBUG_CNC1900I2C(I2C_DEBUG_LEVEL0,"Error:Arbitration lost!\n");
+            }
+            if (i&0x80) {
+                i2c_writew(0x80,IC_INTR_CLR);
+                DEBUG_CNC1900I2C(I2C_DEBUG_LEVEL0,"Error:Timeout!\n");
+            }
+            if (i&0x20) {							//No ACK
+                i2c_writew(0x20,IC_INTR_CLR);
+                i2c_writew(0x700,IC_DATA_CMD);
+                DEBUG_CNC1900I2C(I2C_DEBUG_LEVEL0,"Error:No Slave sends ack!\n");
+            }
+            previous_chip = 0;
+            return -1;
+        }
+    }             //wait all data send
+    time_cnt=0;
+    while (i2c_readw(IC_STAT) & 0x20) {
+        if ((i=i2c_readw(IC_RAW_INTR_STAT)) & 0xe0) {
+            DEBUG_CNC1900I2C(I2C_DEBUG_LEVEL0,"Chipaddress=0x%x, subaddr=0x%x, IC_RAW_INTR_STAT=0x%x\n",
+                  chip, addr, i);
+            i2c_writew(0x03,IC_FIFO_CLR);			//clear tx/rx fifo
+            if (i&0x40) {							//Arbitration Lost
+                i2c_writew(0x40,IC_INTR_CLR);
+                DEBUG_CNC1900I2C(I2C_DEBUG_LEVEL0,"Error:Arbitration lost!\n");
+            }
+            if (i&0x80) {
+                i2c_writew(0x80,IC_INTR_CLR);
+                DEBUG_CNC1900I2C(I2C_DEBUG_LEVEL0,"Error:Timeout!\n");
+            }
+            if (i&0x20) {							//No ACK
+                i2c_writew(0x20,IC_INTR_CLR);
+                i2c_writew(0x700,IC_DATA_CMD);
+                DEBUG_CNC1900I2C(I2C_DEBUG_LEVEL0,"Error:No Slave sends ack!\n");
+            }
+            previous_chip = 0;
+            return -1;
+        }
+        if (time_cnt>=100000) {       //Bus Err
+            i2c_writew(0x1,IC_RESET);
+            i2c_writew(0x0,IC_RESET);
+            i2c_writew(0x1,IC_ENABLE);
+            i2c_writew(0x700,IC_DATA_CMD);     //write stop bit
+            previous_chip = 0;
+            DEBUG_CNC1900I2C(I2C_DEBUG_LEVEL0,"Error:Timeout!\n");
+            return 1;
+        }
+        time_cnt++;
+    }
+    //wait for stop signal
+    return 0;
+}
+
+
+int i2c_write(uchar chip,uint addr, int alen,uchar * buffer, int len)
+{
+    int i;
+    int data_cnt;
+    unsigned int  time_cnt;
+    unsigned char *byte_addr = (unsigned char *) &addr;
+    unsigned char *p = buffer;
+    //    i2c_writew(0x0,IC_RESET);
+    time_cnt=0;
+    while (i2c_readw(IC_STAT)&0x20) {
+        if (time_cnt>=100000) {       //Bus Err
+            i2c_writew(0x1,IC_RESET);
+            i2c_writew(0x0,IC_RESET);
+            i2c_writew(0x1,IC_ENABLE);
+            i2c_writew(0x700,IC_DATA_CMD);     //write stop bit
+            previous_chip = 0;
+            DEBUG_CNC1900I2C(I2C_DEBUG_LEVEL0,"Error:Timeout!\n");
+            return 1;
+        }
+        time_cnt++;
+    }
+    i2c_writew(0x1, IC_ENABLE);
+    i2c_writew(((chip<<1)&0xff)|0x100,IC_DATA_CMD);
+    for (i = alen - 1; i >= 0; i--) {
+        i2c_writew(0x200|byte_addr[i],IC_DATA_CMD);
+    }
+    data_cnt = 0;
+    time_cnt=0;
+    while (data_cnt < len) {
+        if (time_cnt>=100000) {       //Bus Err
+            i2c_writew(0x1,IC_RESET);
+            i2c_writew(0x0,IC_RESET);
+            i2c_writew(0x1,IC_ENABLE);
+            i2c_writew(0x700,IC_DATA_CMD);     //write stop bit
+            previous_chip = 0;
+            DEBUG_CNC1900I2C(I2C_DEBUG_LEVEL0,"Error:Timeout!\n");
+            return 1;
+        }
+        time_cnt++;
+        if (i2c_readw(IC_STAT) & 0x2) {
+            if (data_cnt!=len-1) {
+                i2c_writew(0x200|(*p), IC_DATA_CMD);
+            } else {
+                i2c_writew(0x300|(*p),IC_DATA_CMD);				//Stop
+            }
+            p++;
+            data_cnt++;
+        }
+        if ((i=i2c_readw(IC_RAW_INTR_STAT)) & 0xe0) {
+            DEBUG_CNC1900I2C(I2C_DEBUG_LEVEL0,"Chipaddress=0x%x, subaddr=0x%x, IC_RAW_INTR_STAT=0x%x\n",
+                  chip, addr, i);
+            i2c_writew(0x03,IC_FIFO_CLR);				//clear tx/rx fifo
+            if (i&0x40) {								//Arbitration Lost
+                i2c_writew(0x40,IC_INTR_CLR);
+                DEBUG_CNC1900I2C(I2C_DEBUG_LEVEL0,"Error:Arbitration lost!\n");
+            }
+            if (i&0x80) {
+                i2c_writew(0x80,IC_INTR_CLR);
+                DEBUG_CNC1900I2C(I2C_DEBUG_LEVEL0,"Error:Timeout!\n");
+            }
+            if (i&0x20) {								//No ACK
+                i2c_writew(0x20,IC_INTR_CLR);
+                i2c_writew(0x700,IC_DATA_CMD);		//Stop
+                DEBUG_CNC1900I2C(I2C_DEBUG_LEVEL0,"Error:No Slave sends ack!\n");
+            }
+            previous_chip = 0;
+            return -1;
+        }
+    }
+    time_cnt=0;
+    while (!(i2c_readw(IC_STAT)&0x04)) {
+        if (time_cnt>=100000) {       //Bus Err
+            i2c_writew(0x1,IC_RESET);
+            i2c_writew(0x0,IC_RESET);
+            i2c_writew(0x1,IC_ENABLE);
+            i2c_writew(0x700,IC_DATA_CMD);     //write stop bit
+            previous_chip = 0;
+            DEBUG_CNC1900I2C(I2C_DEBUG_LEVEL0,"Error:Timeout!\n");
+            return 1;
+        }
+        time_cnt++;
+        if ((i=i2c_readw(IC_RAW_INTR_STAT)) & 0xe0) {
+            DEBUG_CNC1900I2C(I2C_DEBUG_LEVEL0,"Chipaddress=0x%x, subaddr=0x%x, IC_RAW_INTR_STAT=0x%x\n",
+                  chip, addr, i);
+            i2c_writew(0x03,IC_FIFO_CLR);				//clear tx/rx fifo
+            if (i&0x40) {						//Arbitration Lost
+                i2c_writew(0x40,IC_INTR_CLR);
+                DEBUG_CNC1900I2C(I2C_DEBUG_LEVEL0,"Error:Arbitration lost!\n");
+            }
+            if (i&0x80) {
+                i2c_writew(0x80,IC_INTR_CLR);
+                DEBUG_CNC1900I2C(I2C_DEBUG_LEVEL0,"Error:Timeout!\n");
+            }
+            if (i&0x20) {						//No ACK
+                i2c_writew(0x20,IC_INTR_CLR);
+                i2c_writew(0x700,IC_DATA_CMD);				//Stop
+                DEBUG_CNC1900I2C(I2C_DEBUG_LEVEL0,"Error:No Slave sends ack!\n");
+            }
+            previous_chip = 0;
+            return -1;
+        }
+    }             //wait all data send
+    time_cnt=0;
+    while (i2c_readw(IC_STAT) & 0x20) {
+        if (time_cnt>=100000) {       //Bus Err
+            i2c_writew(0x1,IC_RESET);
+            i2c_writew(0x0,IC_RESET);
+            i2c_writew(0x1,IC_ENABLE);
+            i2c_writew(0x700,IC_DATA_CMD);     //write stop bit
+            previous_chip = 0;
+            DEBUG_CNC1900I2C(I2C_DEBUG_LEVEL0,"Error:Timeout!\n");
+            return 1;
+        }
+        time_cnt++;
+        if ((i=i2c_readw(IC_RAW_INTR_STAT)) & 0xe0) {
+            DEBUG_CNC1900I2C(I2C_DEBUG_LEVEL0,"Chipaddress=0x%x, subaddr=0x%x, IC_RAW_INTR_STAT=0x%x\n",
+                  chip, addr, i);
+            i2c_writew(0x03,IC_FIFO_CLR);				//clear tx/rx fifo
+            if (i&0x40) {						//Arbitration Lost
+                i2c_writew(0x40,IC_INTR_CLR);
+                DEBUG_CNC1900I2C(I2C_DEBUG_LEVEL0,"Error:Arbitration lost!\n");
+            }
+            if (i&0x80) {
+                i2c_writew(0x80,IC_INTR_CLR);
+                DEBUG_CNC1900I2C(I2C_DEBUG_LEVEL0,"Error:Timeout!\n");
+            }
+            if (i&0x20) {								//No ACK
+                i2c_writew(0x20,IC_INTR_CLR);
+                i2c_writew(0x700,IC_DATA_CMD);		//Stop
+                DEBUG_CNC1900I2C(I2C_DEBUG_LEVEL0,"Error:No Slave sends ack!\n");
+            }
+            previous_chip = 0;
+            return -1;
+        }
+    }
+    return 0;
+}
+
+uchar i2c_reg_read (uchar chip, uchar reg)
+{
+    uchar readed;
+    if (i2c_read(chip, reg, 1, &readed, 1) == 1 ) {
+        printf("Read I2C Error !\n");
+        return 0;
+    }
+    return readed;
+}
+
+void  i2c_reg_write(uchar chip, uchar reg, uchar val)
+{
+    if (i2c_write(chip, reg, 1,&val, 1) == 1) {
+        printf("Write I2C Error !\n");
+    }
+}
+
+void i2c_init(int speed, int slaveaddr)
+{
+    //printf("Init CNC19xx I2C ");
+    ss_ic_sclh_cnt = (45000000 ) /(4*100000);
+    ss_ic_scl_cnt = (45000000 ) /(2*100000);
+    fs_ic_sclh_cnt = (45000000) / (24 * 100000);
+    fs_ic_scl_cnt = (45000000) / (8 * 100000);
+    previous_chip = slaveaddr;
+    i2c_writew(0x0, IC_ENABLE);
+    if (speed > 150000) {
+        i2c_writew(fs_ic_sclh_cnt, IC_SCLH_CNT);
+        i2c_writew(fs_ic_scl_cnt - fs_ic_sclh_cnt, IC_SCLL_CNT);
+        previous_speed_cnt = fs_ic_scl_cnt;
+        default_speed_cnt = fs_ic_scl_cnt;
+    } else {
+        i2c_writew(ss_ic_sclh_cnt, IC_SCLH_CNT);
+        i2c_writew(ss_ic_scl_cnt - ss_ic_sclh_cnt, IC_SCLL_CNT);
+        previous_speed_cnt = ss_ic_scl_cnt;
+        default_speed_cnt = ss_ic_scl_cnt;
+    }
+}
+
+int i2c_set_bus_speed(unsigned int speed) /* only support 100KHz and 400KHz */
+{
+    static unsigned int speed_cnt;
+    if (speed > 150000)
+        speed_cnt = fs_ic_scl_cnt;
+    else
+        speed_cnt = ss_ic_scl_cnt;
+    if (speed_cnt!=previous_speed_cnt) {
+        i2c_writew(0x0, IC_ENABLE);
+        while (!(i2c_readw(IC_STAT)& 0x1));					//wait disabled
+        if ((speed_cnt==ss_ic_scl_cnt)) {					//Standard Speed
+            i2c_writew(ss_ic_sclh_cnt,IC_SCLH_CNT);
+            i2c_writew(ss_ic_scl_cnt-ss_ic_sclh_cnt,IC_SCLL_CNT);
+            previous_speed_cnt = ss_ic_scl_cnt;
+        } else if (speed_cnt==fs_ic_scl_cnt) {					//Fast Speed
+            i2c_writew(fs_ic_sclh_cnt,IC_SCLH_CNT);
+            i2c_writew(fs_ic_scl_cnt-fs_ic_sclh_cnt,IC_SCLL_CNT);
+            previous_speed_cnt =fs_ic_scl_cnt;
+        }
+    }
+    return 0;
+}
+
+unsigned int i2c_get_bus_speed(void)
+{
+    if (previous_speed_cnt ==  fs_ic_scl_cnt)
+        return 400000;
+    if (previous_speed_cnt ==  ss_ic_scl_cnt)
+        return 100000;
+    else
+        return 0;
+}
+
+#endif
diff '--exclude=.svn' -Naur u-boot-2011.06_original/drivers/i2c/cnc1900_i2c.h u-boot-2011.06/drivers/i2c/cnc1900_i2c.h
--- u-boot-2011.06_original/drivers/i2c/cnc1900_i2c.h	1970-01-01 08:00:00.000000000 +0800
+++ u-boot-2011.06/drivers/i2c/cnc1900_i2c.h	2014-07-29 17:28:38.819972000 +0800
@@ -0,0 +1,24 @@
+#ifndef __CNC1900_I2C_H__
+#define	__CNC1900_I2C_H__
+
+#define		IC_ENABLE			0x00
+#define		IC_SCLH_CNT			0x04
+#define		IC_SCLL_CNT			0x08
+#define		IC_DATA_CMD			0x0c
+#define		IC_INTR_STAT		0x10
+#define		IC_RAW_INTR_STAT	0x14
+#define		IC_INTR_MASK		0x18
+#define		IC_INTR_CLR			0x1c
+#define		IC_STAT				0x20
+#define		IC_RX_TL			0x24
+#define		IC_TX_TL			0x28
+#define		IC_TXFLR			0x2c
+#define		IC_RXFLR			0x30
+#define		IC_FIFO_CLR			0x34
+#define		IC_RESET			0x38
+#define		IC_SLV_TIMEOUT_L	0x3c
+#define		IC_SLV_TIMEOUT_H	0x3e
+#define		IC_SLV_TIMEOUT_EN	0x40
+
+#endif
+
diff '--exclude=.svn' -Naur u-boot-2011.06_original/drivers/i2c/Makefile u-boot-2011.06/drivers/i2c/Makefile
--- u-boot-2011.06_original/drivers/i2c/Makefile	2011-06-28 04:22:42.000000000 +0800
+++ u-boot-2011.06/drivers/i2c/Makefile	2014-07-29 17:28:38.819972000 +0800
@@ -42,6 +42,7 @@
 COBJS-$(CONFIG_SPEAR_I2C) += spr_i2c.o
 COBJS-$(CONFIG_TSI108_I2C) += tsi108_i2c.o
 COBJS-$(CONFIG_U8500_I2C) += u8500_i2c.o
+COBJS-$(CONFIG_CNC1900_I2C) += cnc1900_i2c.o
 
 COBJS	:= $(COBJS-y)
 SRCS	:= $(COBJS:.o=.c)
diff '--exclude=.svn' -Naur u-boot-2011.06_original/drivers/mmc/cnc_dw_mmc.c u-boot-2011.06/drivers/mmc/cnc_dw_mmc.c
--- u-boot-2011.06_original/drivers/mmc/cnc_dw_mmc.c	1970-01-01 08:00:00.000000000 +0800
+++ u-boot-2011.06/drivers/mmc/cnc_dw_mmc.c	2014-08-28 18:12:18.974057000 +0800
@@ -0,0 +1,57 @@
+#include <common.h>
+#include <dwmmc.h>
+#include <malloc.h>
+
+#define UHS_REG_EXT   0x108
+
+#define SDMMC_UHS_EXT_DRV_SHIFT 23
+#define SDMMC_UHS_EXT_SMP_SHIFT 16
+
+static void cnc_dwmci_init(struct dwmci_host *host)
+{
+	/* Enable SD controller clock */
+	writel(readl(0xb2100140) | (1 << 7) , 0xb2100140);
+	/* Pin mux for SD0/1 both 4-bit */
+	writel(0x03, 0xB2110024);
+
+	dwmci_writel(host, UHS_REG_EXT, 0xA0000000 | (6 << SDMMC_UHS_EXT_DRV_SHIFT)|(3 << SDMMC_UHS_EXT_SMP_SHIFT));
+}
+
+static unsigned int cnc_dwmci_get_clk(int dev_index)
+{
+	return 90000000;
+}
+
+int cnc_dwmci_add_port(int index, u32 regbase, int bus_width)
+{
+	struct dwmci_host *host = NULL;
+	host = malloc(sizeof(struct dwmci_host));
+	if (!host) {
+		printf("dwmci_host malloc fail!\n");
+		return 1;
+	}
+
+	host->name = "DWMMC";
+	host->ioaddr = (void *)regbase;
+	host->buswidth = bus_width;
+
+	host->dev_index = index;
+	host->mmc_clk = cnc_dwmci_get_clk;
+	/* Add the mmc channel to be registered with mmc core */
+	if (add_dwmci(host, 25000000, 400000)) {
+		debug("dwmmc%d registration failed\n", index);
+		return -1;
+	}
+
+	cnc_dwmci_init(host);
+	return 0;
+}
+
+int board_mmc_init(bd_t *bis)
+{
+	cnc_dwmci_add_port(0, CONFIG_CNC1900_SD0_BASE, 4);
+#ifdef CONFIG_CNC1900_SD1
+	cnc_dwmci_add_port(1, CONFIG_CNC1900_SD1_BASE, 4);
+#endif
+	return 0;
+}
diff '--exclude=.svn' -Naur u-boot-2011.06_original/drivers/mmc/dw_mmc.c u-boot-2011.06/drivers/mmc/dw_mmc.c
--- u-boot-2011.06_original/drivers/mmc/dw_mmc.c	1970-01-01 08:00:00.000000000 +0800
+++ u-boot-2011.06/drivers/mmc/dw_mmc.c	2014-08-28 18:56:15.764773000 +0800
@@ -0,0 +1,371 @@
+/*
+ * (C) Copyright 2012 SAMSUNG Electronics
+ * Jaehoon Chung <jh80.chung@samsung.com>
+ * Rajeshawari Shinde <rajeshwari.s@samsung.com>
+ *
+ * SPDX-License-Identifier:	GPL-2.0+
+ */
+
+#include <common.h>
+#include <malloc.h>
+#include <mmc.h>
+#include <dwmmc.h>
+#include <asm-generic/errno.h>
+
+#define PAGE_SIZE 4096
+
+static int dwmci_wait_reset(struct dwmci_host *host, u32 value)
+{
+	unsigned long timeout = 1000;
+	u32 ctrl;
+
+	dwmci_writel(host, DWMCI_CTRL, value);
+
+	while (timeout--) {
+		ctrl = dwmci_readl(host, DWMCI_CTRL);
+		if (!(ctrl & DWMCI_RESET_ALL))
+			return 1;
+	}
+	return 0;
+}
+
+static void dwmci_set_idma_desc(struct dwmci_idmac *idmac,
+		u32 desc0, u32 desc1, u32 desc2)
+{
+	struct dwmci_idmac *desc = idmac;
+
+	desc->flags = desc0;
+	desc->cnt = desc1;
+	desc->addr = desc2;
+	desc->next_addr = (unsigned int)desc + sizeof(struct dwmci_idmac);
+}
+
+static void dwmci_prepare_data(struct dwmci_host *host,
+		struct mmc_data *data, struct dwmci_idmac *cur_idmac)
+{
+	unsigned long ctrl;
+	unsigned int i = 0, flags, cnt, blk_cnt;
+	ulong data_start, data_end, start_addr;
+
+
+	blk_cnt = data->blocks;
+
+	dwmci_wait_reset(host, DWMCI_CTRL_FIFO_RESET);
+
+	data_start = (ulong)cur_idmac;
+	dwmci_writel(host, DWMCI_DBADDR, (unsigned int)cur_idmac);
+
+	if (data->flags == MMC_DATA_READ)
+		start_addr = (unsigned int)data->dest;
+	else
+		start_addr = (unsigned int)data->src;
+
+	do {
+		flags = DWMCI_IDMAC_OWN | DWMCI_IDMAC_CH ;
+		flags |= (i == 0) ? DWMCI_IDMAC_FS : 0;
+		if (blk_cnt <= 8) {
+			flags |= DWMCI_IDMAC_LD;
+			cnt = data->blocksize * blk_cnt;
+		} else
+			cnt = data->blocksize * 8;
+
+		dwmci_set_idma_desc(cur_idmac, flags, cnt,
+				start_addr + (i * PAGE_SIZE));
+
+		if (blk_cnt <= 8)
+			break;
+		blk_cnt -= 8;
+		cur_idmac++;
+		i++;
+	} while(1);
+
+	data_end = (ulong)cur_idmac;
+	flush_dcache_range(data_start, data_end + ARCH_DMA_MINALIGN);
+
+	ctrl = dwmci_readl(host, DWMCI_CTRL);
+	ctrl |= DWMCI_IDMAC_EN | DWMCI_DMA_EN;
+	dwmci_writel(host, DWMCI_CTRL, ctrl);
+
+	ctrl = dwmci_readl(host, DWMCI_BMOD);
+	ctrl |= DWMCI_BMOD_IDMAC_FB | DWMCI_BMOD_IDMAC_EN;
+	dwmci_writel(host, DWMCI_BMOD, ctrl);
+
+	dwmci_writel(host, DWMCI_BLKSIZ, data->blocksize);
+	dwmci_writel(host, DWMCI_BYTCNT, data->blocksize * data->blocks);
+}
+
+static int dwmci_set_transfer_mode(struct dwmci_host *host,
+		struct mmc_data *data)
+{
+	unsigned long mode;
+
+	mode = DWMCI_CMD_DATA_EXP;
+	if (data->flags & MMC_DATA_WRITE)
+		mode |= DWMCI_CMD_RW;
+
+	return mode;
+}
+
+static int dwmci_send_cmd(struct mmc *mmc, struct mmc_cmd *cmd,
+		struct mmc_data *data)
+{
+	struct dwmci_host *host = (struct dwmci_host *)mmc->priv;
+	ALLOC_CACHE_ALIGN_BUFFER(struct dwmci_idmac, cur_idmac,
+				 data ? DIV_ROUND_UP(data->blocks, 8) : 0);
+	int flags = 0, i;
+	unsigned int timeout = 100000;
+	u32 retry = 10000;
+	u32 mask, ctrl;
+	ulong start = get_timer(0);
+
+	while (dwmci_readl(host, DWMCI_STATUS) & DWMCI_BUSY) {
+		if (get_timer(start) > timeout) {
+			printf("Timeout on data busy\n");
+			return TIMEOUT;
+		}
+	}
+
+	dwmci_writel(host, DWMCI_RINTSTS, DWMCI_INTMSK_ALL);
+
+	if (data)
+		dwmci_prepare_data(host, data, cur_idmac);
+
+	dwmci_writel(host, DWMCI_CMDARG, cmd->cmdarg);
+
+	if (data)
+		flags = dwmci_set_transfer_mode(host, data);
+
+	if ((cmd->resp_type & MMC_RSP_136) && (cmd->resp_type & MMC_RSP_BUSY))
+		return -1;
+
+	if (cmd->cmdidx == MMC_CMD_STOP_TRANSMISSION)
+		flags |= DWMCI_CMD_ABORT_STOP;
+	else
+		flags |= DWMCI_CMD_PRV_DAT_WAIT;
+
+	if (cmd->resp_type & MMC_RSP_PRESENT) {
+		flags |= DWMCI_CMD_RESP_EXP;
+		if (cmd->resp_type & MMC_RSP_136)
+			flags |= DWMCI_CMD_RESP_LENGTH;
+	}
+
+	if (cmd->resp_type & MMC_RSP_CRC)
+		flags |= DWMCI_CMD_CHECK_CRC;
+
+	flags |= (cmd->cmdidx | DWMCI_CMD_START | DWMCI_CMD_USE_HOLD_REG);
+
+	debug("Sending CMD%d\n",cmd->cmdidx);
+
+	dwmci_writel(host, DWMCI_CMD, flags);
+
+	for (i = 0; i < retry; i++) {
+		mask = dwmci_readl(host, DWMCI_RINTSTS);
+		if (mask & DWMCI_INTMSK_CDONE) {
+			if (!data)
+				dwmci_writel(host, DWMCI_RINTSTS, mask);
+			break;
+		}
+	}
+
+	if (i == retry)
+		return TIMEOUT;
+
+	if (mask & DWMCI_INTMSK_RTO) {
+		debug("Response Timeout..\n");
+		return TIMEOUT;
+	} else if (mask & DWMCI_INTMSK_RE) {
+		debug("Response Error..\n");
+		return -1;
+	}
+
+
+	if (cmd->resp_type & MMC_RSP_PRESENT) {
+		if (cmd->resp_type & MMC_RSP_136) {
+			cmd->response[0] = dwmci_readl(host, DWMCI_RESP3);
+			cmd->response[1] = dwmci_readl(host, DWMCI_RESP2);
+			cmd->response[2] = dwmci_readl(host, DWMCI_RESP1);
+			cmd->response[3] = dwmci_readl(host, DWMCI_RESP0);
+		} else {
+			cmd->response[0] = dwmci_readl(host, DWMCI_RESP0);
+		}
+	}
+
+	if (data) {
+		do {
+			mask = dwmci_readl(host, DWMCI_RINTSTS);
+			if (mask & (DWMCI_DATA_ERR | DWMCI_DATA_TOUT)) {
+				debug("DATA ERROR!\n");
+				return -1;
+			}
+		} while (!(mask & DWMCI_INTMSK_DTO));
+
+		dwmci_writel(host, DWMCI_RINTSTS, mask);
+
+		ctrl = dwmci_readl(host, DWMCI_CTRL);
+		ctrl &= ~(DWMCI_DMA_EN);
+		dwmci_writel(host, DWMCI_CTRL, ctrl);
+	}
+
+	udelay(100);
+
+	return 0;
+}
+
+static int dwmci_setup_bus(struct dwmci_host *host, u32 freq)
+{
+	u32 div, status;
+	int timeout = 10000;
+	unsigned long sclk;
+
+	if ((freq == host->clock) || (freq == 0))
+		return 0;
+	/*
+	 * If host->mmc_clk didn't define,
+	 * then assume that host->bus_hz is source clock value.
+	 * host->bus_hz should be set from user.
+	 */
+	if (host->mmc_clk)
+		sclk = host->mmc_clk(host->dev_index);
+	else if (host->bus_hz)
+		sclk = host->bus_hz;
+	else {
+		printf("Didn't get source clock value..\n");
+		return -EINVAL;
+	}
+
+	if (sclk == freq)
+		div = 0;
+	else
+		div = DIV_ROUND_UP(sclk, 2 * freq);
+
+	dwmci_writel(host, DWMCI_CLKENA, 0);
+	dwmci_writel(host, DWMCI_CLKSRC, 0);
+
+	dwmci_writel(host, DWMCI_CLKDIV, div);
+	dwmci_writel(host, DWMCI_CMD, DWMCI_CMD_PRV_DAT_WAIT |
+			DWMCI_CMD_UPD_CLK | DWMCI_CMD_START);
+
+	do {
+		status = dwmci_readl(host, DWMCI_CMD);
+		if (timeout-- < 0) {
+			printf("TIMEOUT error!!\n");
+			return -ETIMEDOUT;
+		}
+	} while (status & DWMCI_CMD_START);
+
+	dwmci_writel(host, DWMCI_CLKENA, DWMCI_CLKEN_ENABLE |
+			DWMCI_CLKEN_LOW_PWR);
+
+	dwmci_writel(host, DWMCI_CMD, DWMCI_CMD_PRV_DAT_WAIT |
+			DWMCI_CMD_UPD_CLK | DWMCI_CMD_START);
+
+	timeout = 10000;
+	do {
+		status = dwmci_readl(host, DWMCI_CMD);
+		if (timeout-- < 0) {
+			printf("TIMEOUT error!!\n");
+			return -ETIMEDOUT;
+		}
+	} while (status & DWMCI_CMD_START);
+
+	host->clock = freq;
+
+	return 0;
+}
+
+static void dwmci_set_ios(struct mmc *mmc)
+{
+	struct dwmci_host *host = (struct dwmci_host *)mmc->priv;
+	u32 ctype;
+
+	debug("Buswidth = %d, clock: %d\n",mmc->bus_width, mmc->clock);
+
+	dwmci_setup_bus(host, mmc->clock);
+	switch (mmc->bus_width) {
+	case 8:
+		ctype = DWMCI_CTYPE_8BIT;
+		break;
+	case 4:
+		ctype = DWMCI_CTYPE_4BIT;
+		break;
+	default:
+		ctype = DWMCI_CTYPE_1BIT;
+		break;
+	}
+
+	dwmci_writel(host, DWMCI_CTYPE, ctype);
+
+	if (host->clksel)
+		host->clksel(host);
+}
+
+static int dwmci_init(struct mmc *mmc)
+{
+	struct dwmci_host *host = (struct dwmci_host *)mmc->priv;
+
+	dwmci_writel(host, DWMCI_PWREN, 1);
+
+	if (!dwmci_wait_reset(host, DWMCI_RESET_ALL)) {
+		debug("%s[%d] Fail-reset!!\n",__func__,__LINE__);
+		return -1;
+	}
+
+	/* Enumerate at 400KHz */
+	dwmci_setup_bus(host, mmc->f_min);
+
+	dwmci_writel(host, DWMCI_RINTSTS, 0xFFFFFFFF);
+	dwmci_writel(host, DWMCI_INTMASK, 0);
+
+	dwmci_writel(host, DWMCI_TMOUT, 0xFFFFFFFF);
+
+	dwmci_writel(host, DWMCI_IDINTEN, 0);
+	dwmci_writel(host, DWMCI_BMOD, 1);
+
+	if (host->fifoth_val) {
+		dwmci_writel(host, DWMCI_FIFOTH, host->fifoth_val);
+	}
+	
+	dwmci_writel(host, DWMCI_CLKENA, 0);
+	dwmci_writel(host, DWMCI_CLKSRC, 0);
+
+	return 0;
+}
+
+int add_dwmci(struct dwmci_host *host, u32 max_clk, u32 min_clk)
+{
+	struct mmc *mmc;
+	int err = 0;
+
+	mmc = calloc(sizeof(struct mmc), 1);
+	if (!mmc) {
+		printf("mmc calloc fail!\n");
+		return -1;
+	}
+
+	mmc->priv = host;
+	host->mmc = mmc;
+
+	sprintf(mmc->name, "%s", host->name);
+	mmc->send_cmd = dwmci_send_cmd;
+	mmc->set_ios = dwmci_set_ios;
+	mmc->init = dwmci_init;
+	mmc->f_min = min_clk;
+	mmc->f_max = max_clk;
+
+	mmc->voltages = MMC_VDD_32_33 | MMC_VDD_33_34 | MMC_VDD_165_195;
+
+	mmc->host_caps = host->caps;
+
+	if (host->buswidth == 8) {
+		mmc->host_caps |= MMC_MODE_8BIT;
+		mmc->host_caps &= ~MMC_MODE_4BIT;
+	} else {
+		mmc->host_caps |= MMC_MODE_4BIT;
+		mmc->host_caps &= ~MMC_MODE_8BIT;
+	}
+	mmc->host_caps |= MMC_MODE_HS | MMC_MODE_HS_52MHz | MMC_MODE_HC;
+
+	err = mmc_register(mmc);
+
+	return err;
+}
diff '--exclude=.svn' -Naur u-boot-2011.06_original/drivers/mmc/Makefile u-boot-2011.06/drivers/mmc/Makefile
--- u-boot-2011.06_original/drivers/mmc/Makefile	2011-06-28 04:22:42.000000000 +0800
+++ u-boot-2011.06/drivers/mmc/Makefile	2014-07-29 17:28:38.819972000 +0800
@@ -38,6 +38,9 @@
 COBJS-$(CONFIG_OMAP_HSMMC) += omap_hsmmc.o
 COBJS-$(CONFIG_PXA_MMC) += pxa_mmc.o
 COBJS-$(CONFIG_S5P_MMC) += s5p_mmc.o
+COBJS-$(CONFIG_DWMMC) += dw_mmc.o
+COBJS-$(CONFIG_CNC_DWMMC) += cnc_dw_mmc.o
+COBJS-$(CONFIG_GENERIC_MMC) += mmc_write.o
 
 COBJS	:= $(COBJS-y)
 SRCS	:= $(COBJS:.o=.c)
diff '--exclude=.svn' -Naur u-boot-2011.06_original/drivers/mmc/mmc.c u-boot-2011.06/drivers/mmc/mmc.c
